package org.computer.aman.metrics.util;

/**
 * ɰʬΥɥޥåפ륯饹Ǥ롥
 * <p>
 * ɥޥåפȤϡɤƤǤʸ<br>
 * (1)ɤΰ(2)ࡤ(3)ʸΰ<br>
 * Τ줫ʬष餫줿ͤǤɽΤǤ롥
 * <p>
 * (1)  CODE(2)  BLANK Ǥ줾ɽ롥<br>
 * (3) ˤĤƤϡˤäʣΥʸ⤢뤿ᡤ
 * ܥ饹òҥ饹롥
 * 
 * @author Hirohisa AMAN &lt;aman@computer.org&gt;
 * @version $Id: CodeLineMap.java,v 1.1 2009/03/26 04:48:33 aman Exp $
 */
public class CodeLineMap
{
    /** ޥå׾ǡʸǤ뤳Ȥɽ */
    public static final String BLANK = "0";

    /** ޥå׾ǡʸɤΰǤ뤳Ȥɽ */
    public static final String CODE = "1";
    
    /**
     * ʬΥɥޥåפꤹ롥 
     * @param aMap ʬΥɥޥå
     */
    public CodeLineMap(final String aMap)
    {
        map = new String(aMap != null ? aMap : "");

        blankCount = 0;
        codeCount = 0;
        commentCount = 0;
        for (int i = 0; i < map.length(); i++ ){
            String ithChar = Character.toString(map.charAt(i));
            if ( BLANK.equals(ithChar) ){
                blankCount++;
            }
            else if ( CODE.equals(ithChar) ){
                codeCount++;
            }
            else{
                commentCount++;
            }
        }
    }
    
    /**
     * ο֤
     * @return ο
     */
    public int getBlankCount()
    {
        return blankCount;
    }

    /**
     * ʸο֤
     * @return ʸο
     */
    public int getCodeCount()
    {
        return codeCount;
    }

    /**
     * ʸο֤
     * @return ʸο
     */
    public int getCommentCount()
    {
        return commentCount;
    }
    
    /**
     * ɥޥåסʰʬˤƤ֤
     * @return ɥޥåסʰʬˤ
     */
    public String getMap()
    {
        return map;
    }
    
    /**
     * ԡʶΤߤιԡޤϲ񤤤Ƥʤԡˤʤ trueʤ false ֤
     * 
     * @return Ԥɤ
     */
    public boolean isBlankLine()
    {
        return (codeCount == 0) && (commentCount == 0);
    }
    
    /** ο */
    private int blankCount;
    
    /** ʸο */
    private int codeCount;
    
    /** ʸο */
    private int commentCount;
    
    /** ޥå:ԤƤФƳʸμбɽ */
    private String map;
}
