package org.computer.aman.metrics.size.loc;

import java.util.ArrayList;
import java.util.Iterator;

import org.computer.aman.io.sourcecode.SourceCodeLine;
import org.computer.aman.io.sourcecode.SourceFile;

/**
 * LOC ¬η̽
 * <p>
 * @author Hirohisa AMAN &lt;aman@computer.org&gt;
 * @version $Id: LOCResultSet.java,v 1.2 2009/03/27 07:22:19 aman Exp $ 
 */
public class LOCResultSet
{
	/**
	 * LOC ¬ˤ̽Υ󥹥󥹤
	 */
	public LOCResultSet(final SourceFile aSourceFile)
	{
		lines = new ArrayList<SourceCodeLine>();
		sourceFile = aSourceFile;
	}

	/**
	 * LOC ¬ʪȤ
	 * SourceCodeLine 󥹥󥹡ʳƥɹԤƤȤΥפ
	 * ꥹȤɲä
	 * 
	 * @param aCodeLine SourceCodeLine 󥹥
	 */
	public void addContents(final SourceCodeLine aCodeLine)
	{
		lines.add(aCodeLine);
	}

    /**
     * Կ֤
     * 
     * @return Կ
     */
    public int getBlankCount()
    {   
        return blank;
    }

    /**
     * LOC ֤ͤ
     * 
     * @return LOC 
     */
    public int getLOC()
    {   
        return loc;
    }

	/**
     * ¬оݤΥե֤
     *
     * @return ¬оݤΥե
     */
    public SourceFile getSourceFile()
    {
        return sourceFile;
    }
	
	/**
	 * եԿʥȡԤޤˤ֤
	 * 
	 * @return եԿʥȡԤޤ
	 */
	public int getTotalLineCount()
	{
		return lines.size();
	}

	/** 
	 * Կ +1 
	 */
	public void incrementBlankCount()
	{
	    blank++;
	}
	
	/**
	 * LOC ͤ +1 
	 */
	public void incrementLOC()
	{
	    loc++;
	}
	
	/**
	 * LOC ¬ʪȤ
	 * SourceCodeLine 󥹥󥹡ʳƥɹԤƤȤΥפ
	 * ΥꥹȤ򥤥ƥ졼Ȥ֤
	 *  
	 * @return SourceCodeLine ꥹȤΥƥ졼
	 */
	public Iterator<SourceCodeLine> iterator()
	{
		return lines.iterator();
	}
	
	/**
	 * ¬̤ξܺ٤ʸȤ֤
	 * 
	 * @return ¬̤ξܺ
	 */
	public String toString()
	{
		StringBuffer buf = new StringBuffer();
		buf.append("[" + sourceFile.getName() + "]\n");
		buf.append("LOC = " + getLOC() + "\n");
		
		buf.append("Կ = " + getTotalLineCount() + "\n\n");
		
		buf.append("--ʥɤơ--------------------------------------\n");
        for (Iterator<SourceCodeLine> itr = iterator(); itr.hasNext(); ){
        	buf.append(itr.next());
        	buf.append("\n");
        }
		buf.append("--ʥɤƤޤǡ------------------------------\n");

        return new String(buf);
	}

	/** Ԥο */
	private int blank;
	
    /** SourceCodeLine 󥹥󥹤ΤΥꥹ */
	private ArrayList<SourceCodeLine> lines;
	
	/** LOC  */
	private int loc;
	
	/** ¬оݤΥե */
	private SourceFile sourceFile;
}
